VirtualBox

source: vbox/trunk/src/VBox/Installer/linux/vboxballoonctrl-service.sh.in@ 42321

Last change on this file since 42321 was 41672, checked in by vboxsync, 12 years ago

Installers/linux: Gentoo fix, missing parts of r41359.

  • Property svn:eol-style set to native
  • Property svn:keywords set to Author Date Id Revision
File size: 8.4 KB
Line 
1#!/bin/sh
2#
3# VirtualBox balloon control daemon init script.
4#
5# Copyright (C) 2006-2011 Oracle Corporation
6#
7# This file is part of VirtualBox Open Source Edition (OSE), as
8# available from http://www.virtualbox.org. This file is free software;
9# you can redistribute it and/or modify it under the terms of the GNU
10# General Public License (GPL) as published by the Free Software
11# Foundation, in version 2 as it comes in the "COPYING" file of the
12# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
13# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
14#
15
16# chkconfig: 35 35 65
17# description: VirtualBox balloon control daemon
18#
19### BEGIN INIT INFO
20# Provides: vboxballoonctrl-service
21# Required-Start: vboxdrv
22# Required-Stop: vboxdrv
23# Default-Start: 2 3 4 5
24# Default-Stop: 0 1 6
25# Description: VirtualBox balloon control daemon
26### END INIT INFO
27
28PATH=$PATH:/bin:/sbin:/usr/sbin
29DEBIAN=%DEBIAN%
30NOLSB=%NOLSB%
31
32[ -f /lib/lsb/init-functions ] || NOLSB=yes
33[ -f /etc/vbox/vbox.cfg ] && . /etc/vbox/vbox.cfg
34
35if [ -n "$INSTALL_DIR" ]; then
36 binary="$INSTALL_DIR/VBoxBalloonCtrl"
37else
38 binary="/usr/lib/%PACKAGE%/VBoxBalloonCtrl"
39fi
40
41# silently exit if the package was uninstalled but not purged,
42# applies to Debian packages only
43[ -z "$DEBIAN" -o -x $binary ] || exit 0
44
45[ -r /etc/default/%PACKAGE% ] && . /etc/default/%PACKAGE%
46
47system=unknown
48if [ -f /etc/redhat-release ]; then
49 system=redhat
50 PIDFILE="/var/lock/subsys/vboxballoonctrl-service"
51elif [ -f /etc/SuSE-release ]; then
52 system=suse
53 PIDFILE="/var/lock/subsys/vboxballoonctrl-service"
54elif [ -f /etc/debian_version ]; then
55 system=debian
56 PIDFILE="/var/run/vboxballoonctrl-service"
57elif [ -f /etc/gentoo-release ]; then
58 system=gentoo
59 PIDFILE="/var/run/vboxballoonctrl-service"
60elif [ -f /etc/arch-release ]; then
61 system=arch
62 PIDFILE="/var/run/vboxballoonctrl-service"
63elif [ -f /etc/slackware-version ]; then
64 system=slackware
65 PIDFILE="/var/run/vboxballoonctrl-service"
66elif [ -f /etc/lfs-release ]; then
67 system=lfs
68 PIDFILE="/var/run/vboxballoonctrl-service.pid"
69else
70 system=other
71 if [ -d /var/run -a -w /var/run ]; then
72 PIDFILE="/var/run/vboxballoonctrl-service"
73 fi
74fi
75
76if [ -z "$NOLSB" ]; then
77 . /lib/lsb/init-functions
78 fail_msg() {
79 echo ""
80 log_failure_msg "$1"
81 }
82 succ_msg() {
83 log_success_msg " done."
84 }
85 begin_msg() {
86 log_daemon_msg "$@"
87 }
88fi
89
90if [ "$system" = "redhat" ]; then
91 . /etc/init.d/functions
92 if [ -n "$NOLSB" ]; then
93 start_daemon() {
94 usr="$1"
95 shift
96 daemon --user $usr $@
97 }
98 fail_msg() {
99 echo_failure
100 echo
101 }
102 succ_msg() {
103 echo_success
104 echo
105 }
106 begin_msg() {
107 echo -n "$1"
108 }
109 fi
110fi
111
112if [ "$system" = "suse" ]; then
113 . /etc/rc.status
114 start_daemon() {
115 usr="$1"
116 shift
117 su - $usr -c "$*"
118 }
119 if [ -n "$NOLSB" ]; then
120 fail_msg() {
121 rc_failed 1
122 rc_status -v
123 }
124 succ_msg() {
125 rc_reset
126 rc_status -v
127 }
128 begin_msg() {
129 echo -n "$1"
130 }
131 fi
132fi
133
134if [ "$system" = "debian" ]; then
135 start_daemon() {
136 usr="$1"
137 shift
138 bin="$1"
139 shift
140 start-stop-daemon --background --chuid $usr --start --exec $bin -- $@
141 }
142 killproc() {
143 start-stop-daemon --stop --exec $@
144 }
145 if [ -n "$NOLSB" ]; then
146 fail_msg() {
147 echo " ...fail!"
148 }
149 succ_msg() {
150 echo " ...done."
151 }
152 begin_msg() {
153 echo -n "$1"
154 }
155 fi
156fi
157
158if [ "$system" = "gentoo" ]; then
159 if [ -f /sbin/functions.sh ]; then
160 . /sbin/functions.sh
161 elif [ -f /etc/init.d/functions.sh ]; then
162 . /etc/init.d/functions.sh
163 fi
164 start_daemon() {
165 usr="$1"
166 shift
167 bin="$1"
168 shift
169 start-stop-daemon --background --chuid $usr --start --exec $bin -- $@
170 }
171 killproc() {
172 start-stop-daemon --stop --exec $@
173 }
174 if [ -n "$NOLSB" ]; then
175 fail_msg() {
176 echo " ...fail!"
177 }
178 succ_msg() {
179 echo " ...done."
180 }
181 begin_msg() {
182 echo -n "$1"
183 }
184 if [ "`which $0`" = "/sbin/rc" ]; then
185 shift
186 fi
187 fi
188fi
189
190if [ "$system" = "arch" ]; then
191 USECOLOR=yes
192 . /etc/rc.d/functions
193 start_daemon() {
194 usr="$1"
195 shift
196 su - $usr -c "$*"
197 test $? -eq 0 && add_daemon rc.`basename $2`
198 }
199 killproc() {
200 killall $@
201 rm_daemon `basename $@`
202 }
203 if [ -n "$NOLSB" ]; then
204 fail_msg() {
205 stat_fail
206 }
207 succ_msg() {
208 stat_done
209 }
210 begin_msg() {
211 stat_busy "$1"
212 }
213 fi
214fi
215
216if [ "$system" = "slackware" ]; then
217 killproc() {
218 killall $1
219 rm -f $PIDFILE
220 }
221 if [ -n "$NOLSB" ]; then
222 fail_msg() {
223 echo " ...fail!"
224 }
225 succ_msg() {
226 echo " ...done."
227 }
228 begin_msg() {
229 echo -n "$1"
230 }
231 fi
232 start_daemon() {
233 usr="$1"
234 shift
235 su - $usr -c "$*"
236 }
237fi
238
239if [ "$system" = "lfs" ]; then
240 . /etc/rc.d/init.d/functions
241 if [ -n "$NOLSB" ]; then
242 fail_msg() {
243 echo_failure
244 }
245 succ_msg() {
246 echo_ok
247 }
248 begin_msg() {
249 echo $1
250 }
251 fi
252 start_daemon() {
253 usr="$1"
254 shift
255 su - $usr -c "$*"
256 }
257 status() {
258 statusproc $1
259 }
260fi
261
262if [ "$system" = "other" ]; then
263 if [ -n "$NOLSB" ]; then
264 fail_msg() {
265 echo " ...fail!"
266 }
267 succ_msg() {
268 echo " ...done."
269 }
270 begin_msg() {
271 echo -n "$1"
272 }
273 fi
274fi
275
276vboxdrvrunning() {
277 lsmod | grep -q "vboxdrv[^_-]"
278}
279
280check_single_user() {
281 if [ -n "$2" ]; then
282 fail_msg "VBOXBALLOONCTRL_USER must not contain multiple users!"
283 exit 1
284 fi
285}
286
287start() {
288 if ! test -f $PIDFILE; then
289 [ -z "$VBOXBALLOONCTRL_USER" ] && exit 0
290 begin_msg "Starting VirtualBox balloon control service";
291 check_single_user $VBOXBALLOONCTRL_USER
292 vboxdrvrunning || {
293 fail_msg "VirtualBox kernel module not loaded!"
294 exit 0
295 }
296 PARAMS="--background"
297 [ -n "$VBOXBALLOONCTRL_INTERVAL" ] && PARAMS="$PARAMS --interval $VBOXBALLOONCTRL_INTERVAL"
298 [ -n "$VBOXBALLOONCTRL_INCREMENT" ] && PARAMS="$PARAMS --balloon-inc $VBOXBALLOONCTRL_INCREMENT"
299 [ -n "$VBOXBALLOONCTRL_DECREMENT" ] && PARAMS="$PARAMS --balloon-dec $VBOXBALLOONCTRL_DECREMENT"
300 [ -n "$VBOXBALLOONCTRL_LOWERLIMIT" ] && PARAMS="$PARAMS --balloon-lower-limit $VBOXBALLOONCTRL_LOWERLIMIT"
301 [ -n "$VBOXBALLOONCTRL_ROTATE" ] && PARAMS="$PARAMS - $VBOXBALLOONCTRL_ROTATE"
302 [ -n "$VBOXBALLOONCTRL_LOGSIZE" ] && PARAMS="$PARAMS -S $VBOXBALLOONCTRL_LOGSIZE"
303 [ -n "$VBOXBALLOONCTRL_LOGINTERVAL" ] && PARAMS="$PARAMS -I $VBOXBALLOONCTRL_LOGINTERVAL"
304 # prevent inheriting this setting to VBoxSVC
305 unset VBOX_RELEASE_LOG_DEST
306 start_daemon $VBOXBALLOONCTRL_USER $binary $PARAMS > /dev/null 2>&1
307 # ugly: wait until the final process has forked
308 sleep .1
309 PID=`pidof $binary 2>/dev/null`
310 if [ -n "$PID" ]; then
311 echo "$PID" > $PIDFILE
312 RETVAL=0
313 succ_msg
314 else
315 RETVAL=1
316 fail_msg
317 fi
318 fi
319 return $RETVAL
320}
321
322stop() {
323 if test -f $PIDFILE; then
324 begin_msg "Stopping VirtualBox balloon control service";
325 killproc $binary
326 RETVAL=$?
327 if ! pidof $binary > /dev/null 2>&1; then
328 rm -f $PIDFILE
329 succ_msg
330 else
331 fail_msg
332 fi
333 fi
334 return $RETVAL
335}
336
337restart() {
338 stop && start
339}
340
341status() {
342 echo -n "Checking for VBox balloon control service"
343 if [ -f $PIDFILE ]; then
344 echo " ...running"
345 else
346 echo " ...not running"
347 fi
348}
349
350case "$1" in
351start)
352 start
353 ;;
354stop)
355 stop
356 ;;
357restart)
358 restart
359 ;;
360force-reload)
361 restart
362 ;;
363status)
364 status
365 ;;
366setup)
367 ;;
368cleanup)
369 ;;
370*)
371 echo "Usage: $0 {start|stop|restart|status}"
372 exit 1
373esac
374
375exit $RETVAL
Note: See TracBrowser for help on using the repository browser.

© 2024 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette